<div [ngClass]="['home-statistic', jds.card]">
  <div [ngClass]="[jds.cardBody, jds.py(0), jds.px(32)]">
    <!-- Dataset -->
    @if (vm.countDataset(); as countDataset) {
      @switch (countDataset.status) {
        @case ('loading') {
          <ng-container
            [ngTemplateOutlet]="loading"
            [ngTemplateOutletContext]="{ last: false }"
          />
        }
        @case ('success') {
          <ng-container
            [ngTemplateOutlet]="content"
            [ngTemplateOutletContext]="{
              name: 'Dataset',
              href: '/dataset',
              total: countDataset.data,
              last: false
            }"
          />
        }
      }
    }

    <!-- Indicator -->
    @if (vm.countIndicator(); as countIndicator) {
      @switch (countIndicator.status) {
        @case ('loading') {
          <ng-container
            [ngTemplateOutlet]="loading"
            [ngTemplateOutletContext]="{ last: false }"
          />
        }
        @case ('success') {
          <ng-container
            [ngTemplateOutlet]="content"
            [ngTemplateOutletContext]="{
              name: 'Indikator',
              href: '/indicator',
              total: countIndicator.data,
              last: false
            }"
          />
        }
      }
    }

    <!-- Visualization -->
    @if (vm.countVisualization(); as countVisualization) {
      @switch (countVisualization.status) {
        @case ('loading') {
          <ng-container
            [ngTemplateOutlet]="loading"
            [ngTemplateOutletContext]="{ last: false }"
          />
        }
        @case ('success') {
          <ng-container
            [ngTemplateOutlet]="content"
            [ngTemplateOutletContext]="{
              name: 'Visualisasi',
              href: '/visualization',
              total: countVisualization.data,
              last: false
            }"
          />
        }
      }
    }

    <!-- Organization -->
    @if (vm.countOrganization(); as countOrganization) {
      @switch (countOrganization.status) {
        @case ('loading') {
          <ng-container
            [ngTemplateOutlet]="loading"
            [ngTemplateOutletContext]="{ last: false }"
          />
        }
        @case ('success') {
          <ng-container
            [ngTemplateOutlet]="content"
            [ngTemplateOutletContext]="{
              name: 'Organisasi',
              href: '/organization',
              total: countOrganization.data,
              last: true
            }"
          />
        }
      }
    }
  </div>
</div>

<ng-template
  #loading
  let-last="last"
>
  <div [ngClass]="[jds.py(24), jds.px(0), last ? jds.borderBottom(0) : '']">
    @for (number of [40, 60]; track number) {
      <div class="wrapper-skeleton">
        <ngx-skeleton-loader
          [theme]="{
            width: number + '%',
            'border-radius': '0',
            height: '22px',
            'margin-bottom': '0'
          }"
        />
      </div>
    }
  </div>
</ng-template>

<ng-template
  #content
  let-name="name"
  let-href="href"
  let-total="total"
  let-last="last"
>
  <a
    [ngClass]="[jds.textDecoration('none')]"
    [style.--color]="jdsBiColor.blue['700']"
    [routerLink]="[href]"
  >
    <div
      [ngClass]="[
        jds.d('flex'),
        jds.alignItems('center'),
        jds.justifyContent('between'),
        jds.py(24),
        jds.px(0),
        jds.borderBottom(1),
        jds.borderColor(jdsBiColor.gray['200']),
        last ? jds.borderBottom(0) : ''
      ]"
    >
      <div>
        <div
          [ngClass]="[jds.fs(36)]"
          [style.lineHeight.px]="54"
          [style.letterSpaccing.em]="0.02"
        >
          {{ total | number: '1.0-0' : 'id' }}
        </div>
        <span [ngClass]="[jds.fw('bold')]">Total {{ name }}</span>
      </div>
      <jds-bi-icon name="arrow-right" />
    </div>
  </a>
</ng-template>
